/* RTS option routine definitions.
 *
 * Copyright 2000 KUN.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* $Id: rtsopt.h,v 1.12 2001/10/25 07:48:22 ejv Exp $ */

#ifndef rtsopt_h
#define rtsopt_h

#include <glib.h>

void process_options(int argc, char* const argv[]);

const char* get_parser_name(void);
const char* get_input_file_name(void);
const char* get_output_file_name(void);
const char* get_alphabet_file_name(void);

extern gboolean parsing_stats_option;
extern gboolean lexer_stats_option;
extern gboolean total_stats_option;
extern gboolean best_parsings_only_option;
extern gboolean show_options_option;
extern gboolean show_penalties_option;
extern gboolean show_timebreak_option;
extern gboolean best_parsings;
extern gboolean io_sync_option;
extern gboolean hybrid_parsing_option;

extern gboolean text_tracing_option;

void show_options();

#endif /* rtsopt_h */
